#ifndef __BZK_TIME__
#define __BZK_TIME__

#include <SDL/SDL.h>

class BZK_Time
{
 public:
  BZK_Time(int interval);
  void Reset();  
  void Start();
  void Refresh();
  Uint32 left_time();
  void nextStep();
  long getFPS();
 private:
  long iFPS;
  long iFrame;
  long iThisTime;
  long iStartTime;
  long next_time;
  int  tickInterval;
};

#endif
