#include "Object.h"

Object::Object()
{
   
   iSize.x = iSize.y = iSize.z = 1;
   iPosition.x = iPosition.y = iPosition.z = 0;
   iVel.x = iVel.y =iVel.z = 0;
//   dMassSetZero(&iMass);
   iM = 1;
};

void Object::Make()
{
   
}

void Object::MakeBody(dWorldID world)
{
      
   iBody = dBodyCreate(world);
   dBodySetPosition(iBody,iPosition.x,iPosition.y,iPosition.z);
   dBodySetLinearVel(iBody,iVel.x,iVel.y,iVel.z);
   printf("Body: %d\n",iBody);
   dMassSetBox(&iMass,iM,iSize.x,iSize.y,iSize.z);
   dBodySetMass(iBody,&iMass);
   printf("Mass\n");
   disabledSteps = 0;
};

void Object::MakeGeom(dSpaceID space)
{
   iGeom = dCreateBox(space,iSize.x,iSize.y,iSize.z);
   printf("Geom %d\n",iGeom);
};

void Object::LinkBodyWithGeom()
{
   dGeomSetBody(iGeom,iBody);
   printf("Link\n");
}

void Object::Update()
{
   
};

void Object::UpdateDisableState()
{
   bool disabled = true;
   if (dBodyIsEnabled(iBody) == 0)
     return;

   const dReal *lv = dBodyGetLinearVel(iBody);
   const dReal *av = dBodyGetAngularVel(iBody);
   
   if ((lv[0]*lv[0]+lv[1]*lv[1]+lv[2]*lv[2]) > DISABLE_THRESHOLD)
	disabled = false;
   
   if ((av[0]*av[0]+av[1]*av[1]+av[2]*av[2]) > DISABLE_THRESHOLD)
     disabled = false;
   
   if (disabled = false)
     disabledSteps++;
   
   if (disabledSteps > AUTO_DISABLE_STEPS)
     dBodyDisable(iBody);
   
};
